#!/usr/bin/perl
package AffiliateLib;

BEGIN {
	use Exporter();
	@ISA = qw(Exporter);
	@EXPORT = qw(
		$ccversion $checkkey $ccprog $showprog $ccpath $ccexecpath $ccwebpath &ccsendmail $expiry $pft %formdata
		&mycrypt &url_encode &read_form &get_merchant &get_affiliate &page_top &page_btm &mer_nav 
		&check_referer &aff_nav &set_cook_and_go &get_cook &get_next &check_url &error &error_msg);
}

if    ($0=~m|^(.*)\\|){ $cgidir = "$1"; }  # win/dos
elsif ($0=~m|^(.*)/| ){ $cgidir = "$1"; }  # Unix
else  {`pwd` =~ /(.*)/; $cgidir = "$1"; }  # Unix

$ccpath = $cgidir . "/";

$ccversion = "Version 3.20 Standard";

$expiry = '+30d'; # default cookie length in days

$pft = "pl"; # perl file type - (pl or cgi)

if($ENV{'PATH_INFO'}=~m|/(.*)/[^/]+|){ $ccwebpath = "$1"; }
elsif($ENV{'REQUEST_URI'}=~m|/(.*)/[^/]*|){ $ccwebpath = "$1"; }
else { $ccwebpath = "clickclocker"; }

#$ccwebpath = $ENV{'PATH_INFO'}; # web directory structure between domain name and clickclocker code

if ($^O =~ /aix|freebsd|hpux|irix|linux|osf|solaris/i )
{ 
	######################### UNIX installation parameters
	$platform = "UNIX";
	$ccexecpath = ""; # path prefix required by clickclocker executable
	#$ccpath = "./"; # path prefix required by perl scripts
	$ccprog = "clickclocker";
	$checkkey = "checkkey";
	$showprog = "show";
	$mailprog = "/usr/sbin/sendmail -t";
} else {
	######################### NT installation parameters
	$platform = "NT"; 
	$ccexecpath = "$cgidir"; # path prefix required by clickclocker executable
	#$ccpath = "clickclocker/"; # path prefix required by perl scripts
	$ccprog = "clickclocker.exe"; # use .exe suffix for NT
	$showprog = "show.exe"; # NT version
	$checkkey = "checkkey.exe";
	$smtpserver = "smtp.legend.co.uk"; # only required for NT
}

#########################
sub ccsendmail {

	local ($toEmail, $fromEmail, $subject, $msg) = @_;
	
	return unless($toEmail =~ /^[\w.+-]+\@[\w.+-]+/);
	return unless($fromEmail =~ /^[\w.+-]+\@[\w.+-]+/);

	my $SMTP_URL = "http://www.affiliatesoftware.info/formmail/ccmail.cgi";
		
	use LWP::UserAgent;
	use HTTP::Request::Common;
		
	my $postit="<$SMTP_URL>";
	my $user_agent=LWP::UserAgent->new;

	my $request= POST $SMTP_URL, [
		recipient=> $toEmail, 
		email=> $fromEmail,
		subject=> $subject,
		message=> $msg	];

	########Post data and get response#######
	$request->authorization_basic($username, $password);
	$response=$user_agent->request($request);
	$content=$response->{_content}; 
}

#########################
sub mycrypt {
    local ($x) = @_;

	$x1 = crypt substr($x,0,8), "CL";
	$x1 .=  crypt substr($x,8,8), "CL";

	return $x1;
}

#########################
sub url_encode {
	local ($string) = @_;

	$string =~ s/([^a-zA-Z0-9_])/uc sprintf("%%%02x",ord($1))/eg;

	return ($string);
}

#########################
sub read_form {

	if($ENV{'REQUEST_METHOD'} =~ /POST/) {
		
		&check_referer;
	
		read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
	
		@pairs = split(/&/, $buffer);
	
		foreach $pair (@pairs) {
		    local($name, $value) = split(/=/, $pair);
			$formdata{$name}=$value;
		}
	}
}

#########################
sub get_affiliate {
	($aff) = @_;
	
	$aff =~ tr/+/ /;
	$aff =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	
	opendir(DIRECTORY, "${ccpath}accepted") or &error_msg( "Can't open directory accepted");
	$files = join (',', readdir(DIRECTORY));
	@filelist = split(/,/, $files);
	closedir DIRECTORY;

	my $match;
LOOP :
	foreach $aff_email (@filelist) {
		$crypted_email = &mycrypt($aff_email);

		if($aff eq $crypted_email) {
			$match=$aff_email;
			last LOOP;
		}
	}

	if(! $match) {
		&error_msg("You have not yet been accepted on our affiliate program");
	}
	open FILEHANDLE, "<${ccpath}accepted/$match";
	%affiliate = split(" ", <FILEHANDLE>);
	close FILEHANDLE;

	foreach $key (keys %affiliate) {
		$affiliate{$key} =~ tr/+/ /;
		$affiliate{$key} =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		if($affiliate{$key} eq "~") { $affiliate{$key}="" };
	}
	
	return %affiliate;
}

#########################
sub get_merchant {

	($auth, $authenticate) = @_;
	$auth =~ tr/+/ /;
	$auth =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;

	opendir(DIRECTORY, "${ccpath}merchant") or &error_msg("Can't open directory merchant");
	$files = join (',', readdir(DIRECTORY));
	@filelist = split(/,/, $files);
	closedir DIRECTORY;

	my $match;
	foreach $mer_email (@filelist) {
		$crypted_email = crypt $mer_email, "CLICK";
	
		if(! $authenticate && $mer_email =~ /@/) {
			$match=$mer_email;
			last;
		}
		elsif($auth eq $crypted_email) {
			$match=$mer_email;
			last;
		}
	}
	
	if(! $match) {
		&error_msg("Authentication denied");
	}
	open FILEHANDLE, "<${ccpath}merchant/$match";
	%merchant = split(" ", <FILEHANDLE>);
	close FILEHANDLE;
	
	foreach $key (keys %merchant) {
		$merchant{$key} =~ tr/+/ /;
		$merchant{$key} =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		if($merchant{$key} eq "~") { $merchant{$key}="" };
	}
	
	return %merchant;
}

#########################
sub page_top {
	local ($title) = @_;

print <<"(END MESSAGE)";
Content-type: text/html

<html>
<head>
<title>$title</title>
<LINK REL=stylesheet HREF="style.css" TYPE="text/css">
</head>

<body bgcolor="Silver">
<br>
<div align="center">
<table border=0 cellspacing=0 cellpadding=0>
<TR>
<TD bgcolor="silver" width="23"><IMG height=20 src="images/curve-tl.gif" width=23 border=0></TD>
<TD colspan="3" width="550"><IMG height=2 src="images/blank.gif" width=550 border=0></TD>
<TD bgcolor="silver" width="23"><IMG height=20 src="images/curve-tr.gif" width=23 border=0></TD>
</TR>
<tr><td width="23">&nbsp;</td>
<td width="100" valign="top" align="center">
(END MESSAGE)
}

#########################
sub page_btm {
print <<"(END MESSAGE)";
<br>
<div align="right">
<a target="_blank" href="http://affiliatesoftware.clickclocker.com"><img src="images/clickclocker.gif" align="right" width=154 height=52 border=0 alt="$ccversion"></a>
</div>
	</td>
<td width="23">&nbsp;</td></tr>
<TR>
	<TD bgcolor="silver"><IMG height=20 src="images/curve-bl.gif" width=23 border=0></TD>
	<TD colspan="3" width="550"><IMG height=2 src="images/blank.gif" width=550 border=0></TD>
	<TD bgcolor="silver"><IMG height=20 src="images/curve-br.gif" width=23 border=0></TD>
</TR>
</table>
<br>
</div>
</body>
</html>
(END MESSAGE)
}

########################
sub mer_nav {
	local ($email) = @_;
	my $auth = crypt $email, "CLICK";

print <<"(END MESSAGE)";
<table width=100 cellpadding=0>
<tr><td valign="top"><h3>Navigation</h3></td></tr>
<tr><td><a href="mer_admin.$pft?auth=$auth">Affiliate&nbsp;Admin</a><br><br></td></tr>
<tr><td><a href="mer_broadcast.$pft?auth=$auth">Affiliate&nbsp;Broadcast</a><br><br></td></tr>
<tr><td><a href="mer_change.$pft?auth=$auth">Change Details</a><br><br></td></tr>
<tr><td><a href="mer_stats.$pft?auth=$auth">Reports</a><br><br></td></tr>
<tr><td><a href="mer_sales.$pft?auth=$auth">Sales&nbsp;Admin</a><br><br></td></tr>
<tr><td><a href="mer_banners.$pft?auth=$auth">View&nbsp;Banners</a><br><br></td></tr>
<tr><td><a href="http://www.clickclocker.com/professional.htm">Upgrade to<br>ClickClocker Professional</a><br><br></td></tr>
<tr><td><br><br><a href="mailto:support\@clickclocker.com?subject=ClickClocker Enquiry">Contact&nbsp;ClickClocker</a><br><br></td></tr>
</table></td>
<td width="40" valign="top" background="images/line.gif">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>
<td width="400" align="left" valign="top">
(END MESSAGE)
}

#########################
sub aff_nav {
	local ($aff) = @_;
	
print <<"(END MESSAGE)";
<table width=100>
<tr><td valign="top"><h3>Navigation</h3></td></tr>
<tr><td><a href="banners.$pft?aff=$aff">Choose Links</a><br><br></td></tr>
<tr><td><a href="change.$pft?aff=$aff">Change Details</a><br><br></td></tr>
<tr><td><a href="stats.$pft?aff=$aff">View Reports</a><br><br></td></tr>
<tr><td><a href="mailto:$merchant{'mer_email'}?subject=Affiliate Program Enquiry">Contact Us</a><br><br></td></tr>
</table></td>
<td width="40" valign="top" background="images/line.gif">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>
<td width="400" align="left" valign="top">
(END MESSAGE)
}

#########################
sub get_cook {

	my $result = 0;

	use CGI;
	$co = new CGI '';

	%hash = $co->cookie('afili8');

	if($co->param('aff_name')) {
		$result = 1;
	}
	return ($result, \%hash);
}

#########################
sub set_cook_and_go {
	local @params = @_;

	%hash = %{$params[0]};
	$url = $params[1];

	use CGI qw(:cgi);

	my $co = new CGI '';

	my $cc_cookie = $co->cookie
	(
		-name=>'clickclocker',
		-value=>\%hash,
		-expires=>'+365d'
	);

	print $co->redirect(
		-url => $url,
		-cookie=>$cc_cookie);
}

#########################
sub get_next {
	local @key = @_;

	# read hash from file
	if(open FILEHANDLE, "<${ccpath}counters.dat") {
	    %counter = split(" ", <FILEHANDLE>);
		close FILEHANDLE;
	} else {
		$counter{$key[0]} = 123;
	}

	# increment counter
	if($counter{$key[0]}) {
		$counter{$key[0]}++;
	} else {
		$counter{$key[0]} = 123;
	}


	# write hash file
	open FILEHANDLE, ">${ccpath}counters.dat" or error_msg( "Cannot open counters.dat");

	$, = " ";

	print FILEHANDLE %counter;
	close FILEHANDLE;

	# return counter
	return $counter{$key[0]};
}

#########################
sub check_url {

    @referers = @_;

    # Localize the check_referer flag which determines if user is valid.     #
    local($check_referer) = 0;

    # If a referring URL was specified, for each valid referer, make sure    #
    # that a valid referring URL was passed

    if ($ENV{'HTTP_REFERER'}) {
        foreach $referer (@referers) {
            if ($ENV{'HTTP_REFERER'} =~ m|$referer|i) {
				#&error_msg("$referer - $ENV{'HTTP_REFERER'}");
                $check_referer = 1;
                last;
            }
        }
    }
    else {
        $check_referer = 1;
    }

    # If the HTTP_REFERER was invalid, send back an error.                   #
    if ($check_referer != 1) { &error('bad_referer') }
}

sub check_referer {
	my $host = "http://$ENV{'HTTP_HOST'}"; 
	my $referer = $ENV{'HTTP_REFERER'}; 
	if($referer){ 
		if($referer !~ /^$host/i){ 
			&error_msg('Bad Referrer. Access Denied');
		} 
	} 
}

#########################
sub error {
    # Localize variables and assign subroutine input.                        #
    local($error,@error_fields) = @_;
    local($host);

    if ($error eq 'bad_referer') {
        if ($ENV{'HTTP_REFERER'} =~ m|^https?://([\w\.]+)|i) {
            $host = $1;
			&error_msg('Bad Referrer - Access Denied');
        }
    }
exit;
}

#########################
sub error_msg {
	local @error = @_;
	print <<"(END ERRORMSG)";
Content-type: text/html

<html>
 <head>
  <title>Error Encountered</title>
 </head>
 <body>
  <center>
  <h3>An error was encountered while processing your request</h3>
   <br>
   <font color=green>@error</font>
   <br>
  </center>
 </body>
</html>
(END ERRORMSG)
	exit;
}

return 1;

END { }
