#!/usr/bin/perl

my %months = (
	'Jan', '01', 'Feb', '02', 'Mar', '03', 'Apr', '04', 'May', '05', 'Jun', '06', 
	'Jul', '07', 'Aug', '08', 'Sep', '09', 'Oct', '10', 'Nov', '11', 'Dec', '12' );

use File::Basename; 
use lib dirname ($0);
use AffiliateLib;

open LOGFILE, ">>${ccpath}log/buy.log";
print LOGFILE "Started buy.${pft} ****\n";

################# read cookie
use CGI;
my $co = new CGI '';
my %clickclocker = $co->cookie('clickclocker');

if(! exists($clickclocker{'aff_web'})) {
	print LOGFILE "No cookie\n";
	close LOGFILE;
	&do_image;
	exit;
}

print LOGFILE "Got cookie\n";
print LOGFILE "->$ENV{'QUERY_STRING'}<-\n";
close LOGFILE;

################# read params
@pairs=split(/&/,$ENV{'QUERY_STRING'});
my %ccparams;
foreach $pair(@pairs){
        ($key, $value)=split (/=/, $pair);
        $value=~tr/+/ /;
        $value=~s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
        $ccparams{$key}=$value;
}

################# find affiliate record
opendir(DIRECTORY, "${ccpath}accepted") or error_msg( "Can't open directory accepted");
my $files = join (',', readdir(DIRECTORY));
my @filelist = split(/,/, $files);
closedir DIRECTORY;

my %aff;
foreach $aff_email (@filelist) {
	if(open FILEHANDLE, "<${ccpath}accepted/$aff_email") {
		%aff = split(" ", <FILEHANDLE>);
		close FILEHANDLE;

		foreach $key (keys %aff) {
			$aff{$key} =~ tr/+/ /;
			$aff{$key} =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		}

		if($clickclocker{'aff_web'} eq $aff{'aff_web'}) {
			$aff_amount = ($aff{'aff_method'} eq "C") ? $aff{'aff_com'} : $aff{'aff_fix'};

			################# set date
			open(TODAYSDATE, "${ccpath}today |");
			$clickclocker{'today'} = <TODAYSDATE>;
			close TODAYSDATE;
			
			################# construct clickclocker filename
			$cclogfile = "cc" . 
				substr($clickclocker{'today'}, 9, 2) . 
				$months{substr($clickclocker{'today'}, 3, 3)} .
				substr($clickclocker{'today'}, 0, 2) . ".csv";
			
			################# write a record to impression log to ensure sale is found
			open FILEHANDLE, ">>${ccpath}log/${cclogfile}" or error_msg("Cannot open file ${ccpath}log/${cclogfile}");
			print FILEHANDLE "$clickclocker{'banner'},";
			print FILEHANDLE "$clickclocker{'aff_web'}\n";
			close FILEHANDLE;

			################# write sale to file
			open FILEHANDLE, ">>${ccpath}reports/sales.csv" or error_msg("Cannot open file ${ccpath}reports/sales.csv");

			print FILEHANDLE "$clickclocker{'today'},";
			print FILEHANDLE "$clickclocker{'aff_web'},";
			print FILEHANDLE "$clickclocker{'banner'},";
			print FILEHANDLE "$ccparams{'id'},";
			print FILEHANDLE "$ccparams{'amount'},";
			print FILEHANDLE "$aff{'aff_method'},";
			print FILEHANDLE "$ccparams{'bonus'},";
			print FILEHANDLE "$ccparams{'name'},";
			print FILEHANDLE "$aff_amount\n";

			close FILEHANDLE;

			open LOGFILE, ">>${ccpath}log/buy.log";
			print LOGFILE "Completed buy.${pft} with affiliate matched\n";
			close LOGFILE;

			last;
		}
	}
}
&do_image;

sub do_image {
	my $image = "${ccpath}images/invisible.gif"; 
	open(IMAGE, "<$image");
	my $n_bytes = (stat ($image))[7]; 
	print "Content-type: image/gif\n"; 
	print "Content-length: $n_bytes\n"; 
	print "Pragma: no-cache\n\n"; 
	print <IMAGE>; 
	close(IMAGE);
}
