#!/usr/bin/perl
use File::Basename; 
use lib dirname ($0);
use AffiliateLib;

################# parse form and apply changes
&read_form;

if($formdata{'auth'}) {
    $auth = $formdata{'auth'};
	$sub = $formdata{'sub'};
} else {
	################# read passed vars
	use CGI qw(param);
	$auth = param("auth");
	$sub = param("sub");
	$aff = param("aff");
}

################# read merchant record
%merchant = get_merchant($auth, 1); # 1=authenticate

################# apply updates
foreach $key (keys %formdata) {
	if($formdata{$key} eq "Accept") {

		open AFFILIATE_FILE, "<${ccpath}applications/$key";
		%aff = split(" ", <AFFILIATE_FILE>);
		close AFFILIATE_FILE;

		$aff{'aff_method'} = $formdata{'aff_method'};
		$aff{'aff_com'} = $formdata{'aff_com'};
		$aff{'aff_cook'} = $formdata{'aff_cook'};
		$aff{'aff_fix'} = $formdata{'aff_fix'};

		open AFFILIATE_FILE, ">${ccpath}applications/$key";
		$, = " ";
		print AFFILIATE_FILE %aff;
		close AFFILIATE_FILE;

		open AFF_COOKLEN, ">${ccpath}cookies/$aff{'aff_web'}";
		print AFF_COOKLEN "+";
		print AFF_COOKLEN $aff{'aff_cook'};
		print AFF_COOKLEN "d";
		close AFF_COOKLEN;

		rename "${ccpath}applications/$key", "${ccpath}accepted/$key";

		################ inform affiliate
		$aff_name = $aff{'aff_name'};
		$aff_name =~ tr/+/ /;

		&ccsendmail(
			$aff{'aff_email'},
			$merchant{'mer_email'},
			"$merchant{'mer_web'} affiliate program", 
			"Dear $aff_name,\n\nWe are pleased to inform you that your application to the $merchant{'mer_web'} affiliate program has been accepted. Please go to the control panel at $merchant{'mer_web'}/${ccwebpath}/signin.${pft} for linking information and detailed performance reporting.\n\nThankyou for your application.\n\nAffiliate Manager\n$merchantname\n");
	}
	elsif($formdata{$key} eq "Reject") {

		open AFFILIATE_FILE, "<${ccpath}applications/$key";
		%aff = split(" ", <AFFILIATE_FILE>);
		close AFFILIATE_FILE;
		
		################ inform affiliate
		$aff_name = $aff{'aff_name'};
		$aff_name =~ tr/+/ /;

		&ccsendmail(
			$aff{'aff_email'},
			$merchant{'mer_email'},
			"$merchant{'mer_web'} affiliate program", 
			"Dear $aff_name,\n\nWe regret to inform you that your application to the $merchant{'mer_web'} affiliate program has not been accepted. This does not mean we disapprove of the quality or value of your web site. We determine how many and what type of web sites we will accept for various reasons.\n\nThankyou for your application.\n\nAffiliate Manager\n$merchantname\n");

		###### move record to accept dir
		rename "${ccpath}applications/$key", "${ccpath}rejected/$key";
	}
	elsif($formdata{$key} eq "Accept+Affiliate") {
		open AFFILIATE_FILE, "<${ccpath}rejected/$key";
		%aff = split(" ", <AFFILIATE_FILE>);
		close AFFILIATE_FILE;
		
		$aff{'aff_com'} = $formdata{'aff_com'};
		$aff{'aff_method'} = $formdata{'aff_method'};
		$aff{'aff_cook'} = $formdata{'aff_cook'};
		$aff{'aff_fix'} = $formdata{'aff_fix'};

		open AFFILIATE_FILE, ">${ccpath}rejected/$key";
		$, = " ";
		print AFFILIATE_FILE %aff;
		close AFFILIATE_FILE;

		open AFF_COOKLEN, ">${ccpath}cookies/$aff{'aff_web'}";
		print AFF_COOKLEN "+";
		print AFF_COOKLEN $aff{'aff_cook'};
		print AFF_COOKLEN "d";
		close AFF_COOKLEN;

		rename "${ccpath}rejected/$key", "${ccpath}accepted/$key";

		################ inform affiliate
		$aff_name = $aff{'aff_name'};
		$aff_name =~ tr/+/ /;

		&ccsendmail(
			$aff{'aff_email'},
			$merchant{'mer_email'},
			"$merchant{'mer_web'} affiliate program", 
			"Dear $aff_name,\n\nWe are pleased to inform you that your application to the $merchant{'mer_web'} affiliate program has been accepted. Please go to the control panel at $merchant{'mer_web'}/${ccwebpath}/signin.${pft} for linking information and detailed performance reporting.\n\nThankyou for your application.\n\nAffiliate Manager\n$merchantname\n");
	}
	elsif($formdata{$key} eq "Delete+Affiliate") {
		unlink "${ccpath}rejected/$key";
	}
	elsif($formdata{$key} eq "Apply+Changes") {
		open AFFILIATE_FILE, "<${ccpath}accepted/$key";
		%aff = split(" ", <AFFILIATE_FILE>);
		close AFFILIATE_FILE;
		
		$aff{'aff_com'} = $formdata{'aff_com'};
		$aff{'aff_method'} = $formdata{'aff_method'};
		$aff{'aff_cook'} = $formdata{'aff_cook'};
		$aff{'aff_fix'} = $formdata{'aff_fix'};

		open AFFILIATE_FILE, ">${ccpath}accepted/$key";
		$, = " ";
		print AFFILIATE_FILE %aff;
		close AFFILIATE_FILE;

		open AFF_COOKLEN, ">${ccpath}cookies/$aff{'aff_web'}";
		print AFF_COOKLEN "+";
		print AFF_COOKLEN $aff{'aff_cook'};
		print AFF_COOKLEN "d";
		close AFF_COOKLEN;
	}
	elsif($formdata{$key} eq "Reject+Affiliate") {

		open AFFILIATE_FILE, "<${ccpath}accepted/$key";
		%aff = split(" ", <AFFILIATE_FILE>);
		close AFFILIATE_FILE;
		
		################ inform affiliate
		$aff_name = $aff{'aff_name'};
		$aff_name =~ tr/+/ /;

		&ccsendmail(
			$aff{'aff_email'},
			$merchant{'mer_email'},
			"$merchant{'mer_web'} affiliate program", 
			"Dear $aff_name,\n\nWe regret to inform you that your application to the $merchant{'mer_web'} affiliate program has not been accepted. This does not mean we disapprove of the quality or value of your web site. We determine how many and what type of web sites we will accept for various reasons.\n\nThankyou for your application.\n\nAffiliate Manager\n$merchantname\n");

		###### move record to accept dir
		rename "${ccpath}accepted/$key", "${ccpath}rejected/$key";
	}
}

################# count affiliates in each dir

opendir(DIRECTORY, "${ccpath}applications") or &error_msg("Can't open directory applications");
$files = join (',', readdir(DIRECTORY));
@app_filelist = split(/,/, $files);
closedir DIRECTORY;

opendir(DIRECTORY, "${ccpath}accepted") or error_msg( "Can't open directory accepted");
$files = join (',', readdir(DIRECTORY));
@accept_filelist = split(/,/, $files);
closedir DIRECTORY;

opendir(DIRECTORY, "${ccpath}rejected") or error_msg( "Can't open directory rejected");
$files = join (',', readdir(DIRECTORY));
@rej_filelist = split(/,/, $files);
closedir DIRECTORY;


################# display info to Merchant
&page_top("Affiliate Administration");

&mer_nav($merchant{'mer_email'});

print "<h3>Affiliate Administration</h3>";
print "<a href=\"mer_admin.${pft}?auth=$auth\">Applications: " . ($#app_filelist - 1) . "</a>" .
      "<br><a href=\"mer_admin.${pft}?auth=$auth&sub=acc\">Accepted Affiliates: " . ($#accept_filelist - 1) . "</a>" .
	  "<br><a href=\"mer_admin.${pft}?auth=$auth&sub=rej\">Rejected Affiliates: " . ($#rej_filelist - 1) . "</a>";
print "<br><br><center>";

if($sub eq "acc") {
	print "<h3>Accepted Affiliates</h3>";
	$btn_text = "Apply Changes";
	$btn_text2 = "Reject Affiliate";
	$affiliate_dir = "${ccpath}accepted";
	@filelist = @accept_filelist;
} elsif($sub eq "rej") {
	print "<h3>Rejected Affiliates</h3>";
	$btn_text = "Accept Affiliate";
	$btn_text2 = "Delete Affiliate";
	$affiliate_dir = "${ccpath}rejected";
	@filelist = @rej_filelist;
} else {
	print "<h3>Affiliate Applications</h3>";
	$btn_text = "Accept";
	$btn_text2 = "Reject";
	$affiliate_dir = "${ccpath}applications";
	@filelist = @app_filelist;
}

print "</center><table border=0 cellspacing=3 cellpadding=0>";

################# display affiliates
foreach $affiliate (@filelist) {

	if($affiliate =~ /@/ && open FILEHANDLE, "<$affiliate_dir/$affiliate") {

	%aff = split(" ", <FILEHANDLE>);
	close FILEHANDLE;

	foreach $key (keys %aff) {
	    $aff{$key} =~ tr/~/ /;
		$aff{$key} =~ tr/+/ /;
		$aff{$key} =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	}

	$aff_com = sprintf "%.2f", $aff{'aff_com'};
	$aff_cook = sprintf "%.0f", $aff{'aff_cook'};
	$aff_method = $aff{'aff_method'};

	if($aff_cook==0) { $aff_cook=90; }
	$aff_fix = sprintf "%.2f", $aff{'aff_fix'};

	if($aff_method eq "F") {
		$f_checked = "checked";
		$c_checked = "";
	} else {
		$f_checked = "";
		$c_checked = "checked";
	}
	
	if(!$aff{'aff_url'}) {
		$aff{'aff_url'} = "http://" . $aff{'aff_web'};
	}

	print <<"(END HTML1)";

<form action=mer_admin.${pft} method=post>
<input type=hidden name=auth value="$auth"></input>
<input type=hidden name=sub value="$sub"></input>
<input type=hidden name=aff_web value="$aff{'aff_web'}"></input>

<tr>
	<td>&nbsp;</td>
	<td valign="top">Affiliate Id</td>
	<td valign="top">$aff{'aff_web'} ($aff{'id'})</td>
	<td colspan=3>&nbsp;</td>
</tr>

<tr>
	<td>&nbsp;</td>
	<td valign="top">Company Name</td>
	<td valign="top">$aff{'aff_org'}</td>
	<td valign="top">VAT Reg.</td>
	<td valign="top">$aff{'aff_vat_no'}</td>
	<td>&nbsp;</td>
</tr>
<tr>
	<td>&nbsp;</td>
	<td valign="top">Web Site URL</td>
	<td valign="top"><a target=_blank href="$aff{'aff_url'}">$aff{'aff_web'}</a></td>
	<td valign="top">Email</td>
	<td valign="top"><a href="mailto:$aff{'aff_email'}">$aff{'aff_email'}</a></td>
	<td>&nbsp;</td>
</tr>
<tr>
	<td>&nbsp;</td>
	<td valign="top">Contact</td>
	<td valign="top">$aff{'aff_name'}</td>
	<td valign="top">Password</td>
	<td valign="top">$aff{'aff_pwd'}</td>
	<td>&nbsp;</td>
</tr>
<tr>
	<td>&nbsp;</td>
	<td valign="top">Address</td>
	<td valign="top" colspan=3>$aff{'aff_addr1'}, $aff{'aff_addr2'}, $aff{'aff_addr3'}, $aff{'aff_region'}, $aff{'aff_country'}, $aff{'aff_zip'}</td>
	<td>&nbsp;</td>
</tr>
<tr>
	<td>&nbsp;</td>
	<td valign="top">Telephone</td>
	<td valign="top">$aff{'aff_phone'}<br><br></td>
	<td>&nbsp;</td>
</tr>
<tr>
	<td>&nbsp;</td>
	<td valign="top">Commission Method</td>
	<td valign="top" align=left><input type=radio value="F" name=aff_method $f_checked>Fixed <br><input type=radio value="C" name=aff_method $c_checked>Percentage </td>
	<td colspan=2 valign="top" align=left><b>&pound; &nbsp;</b><input type=text value="$aff_fix" style='text-align:right' name=aff_fix size=12 maxlength=12></input>
	<br><b>% </b><input type=text value="$aff_com" style='text-align:right' name=aff_com size=12 maxlength=12></input></td>
	<td>&nbsp;</td>
</tr>
<tr>
	<td>&nbsp;</td>
	<td valign="top">Cookie (days)</td>
	<td valign="top" align=left><input type=text value="$aff_cook" style='text-align:right' name=aff_cook size=9 maxlength=9></input></td>
	<td colspan=3>&nbsp;</td>
</tr>
<tr>
	<td>&nbsp;</td>
	<td valign="top">&nbsp;</td>
	<td valign="top" colspan=2><br><input type=submit name=$aff{'aff_email'} value="$btn_text"></input>&nbsp;&nbsp;&nbsp;&nbsp;<input type=submit name=$aff{'aff_email'} value="$btn_text2"></input></td>
</tr>
<tr><td colspan="5"><hr><br></td></tr>
</form>
(END HTML1)
	}
}

print "</table>";

&page_btm;
