#!/usr/bin/perl
use File::Basename; 
use lib dirname ($0);
use AffiliateLib;

################# read form
&read_form;

if(defined($formdata{'mer_key'})) {

	################# validate key
	open(CHECKKEY, "${ccpath}${checkkey} $formdata{'mer_key'} professional |") or
		&error_msg("Can't find check program ${ccpath}${checkkey}");
	$result = <CHECKKEY>;
	close CHECKKEY;
	$msg = "Invalid Product Key - retry or contact clickclocker - $result";
	&error_msg($msg) if($result =~ /fail/);

	open PRODKEY, ">${ccpath}clocker.key" or &error_msg("Cannot open ${ccpath}clocker.key");
	print PRODKEY "$formdata{'mer_key'}";
	close PRODKEY;
	 	
	################# set up directories
	mkdir("${ccpath}accepted", 0755);
	mkdir("${ccpath}applications", 0755);
	mkdir("${ccpath}banners", 0755);
	mkdir("${ccpath}cookies", 0755);
	mkdir("${ccpath}log", 0755);
	mkdir("${ccpath}merchant", 0755);
	mkdir("${ccpath}rejected", 0755);
	mkdir("${ccpath}reports", 0755);
	
	################# set up file permissions
	chmod(0755, "${ccpath}${ccprog}");
	chmod(0755, "${ccpath}${showprog}");

	################# check merchant not already set up
	opendir(DIRECTORY, "${ccpath}merchant") or &error_msg("Can't open merchant directory");
	$filelist = join (', ', readdir(DIRECTORY));

	if($filelist =~ /$formdata{'mer_email'}/) {
		&error_msg("You have already set up ClickClocker using - $formdata{'mer_email'}");
	}
	elsif($filelist =~ /@/) {
		&error_msg("You have already set up using a different email address - $filelist");
	}
	closedir DIRECTORY;

	$url="http://" . $formdata{'mer_web'};
	$formdata{'mer_url'} = $url;
	$url =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;

	open CONFIG, ">${ccpath}Config" or &error_msg("Cannot open the Config file");
	print CONFIG 	"log/clocker.log\n" .
					"log/impressions.csv\n" .
					"$url\n" .
					"clocker.key\n" .
					"reports/clickclocker.csv\n\n";
	close CONFIG;

	################# write merchant file

	if($formdata{'mer_vat_no'} eq "") {
		$formdata{'mer_vat_no'}="~";
	}
	if($formdata{'mer_addr2'} eq "") {
		$formdata{'mer_addr2'}="~";
	}

	open(TODAYSDATE, "${ccpath}today |");
	$formdata{'mer_date'} = <TODAYSDATE>;
	close TODAYSDATE;

	open FILEHANDLE, ">${ccpath}merchant/$formdata{'mer_email'}" or &error_msg("Cannot open file merchant/$formdata{'mer_email'}");

	$, = " ";

	print FILEHANDLE %formdata;
	close FILEHANDLE;

	foreach $key (keys %formdata) {
		$formdata{$key} =~ tr/+/ /;
		$formdata{$key} =~ s/~//;
		$formdata{$key} =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	}

	################ inform merchant
	&ccsendmail(
		"$formdata{'mer_email'} ; sales\@clickclocker.com",
		"admin\@clickclocker.com",
		"$merchant{'mer_web'} affiliate program", 
		"Dear Affiliate Manager,\n\nThankyou for choosing clickclocker as your affiliate management software. Your details have been set up as follows:\n\nCompany: $formdata{'mer_org'} \nWeb: $url\nName : $formdata{'mer_name'}\nEmail : $formdata{'mer_email'}\nVAT No. $formdata{'mer_vat_no'}\nAddress : $formdata{'mer_addr1'}, $formdata{'mer_addr2'}, $formdata{'mer_addr3'}, $formdata{'mer_region'}, $formdata{'mer_country'}, $formdata{'mer_zip'}\nTelephone : $formdata{'mer_phone'}\n\nThankyou.\n\nClickClocker\n");

	# redirect merchant

	$crypted_email = crypt $formdata{'mer_email'}, "CLICK";

	use CGI;

	$co = new CGI '';
	print $co->redirect(
		-url => "mer_stats.${pft}?auth=$crypted_email");

}

print <<"(END MESSAGE2)";
Content-type: text/html

<html>
<head>
	<title>Affiliate Program - Merchant Set Up</title>
	<LINK REL=stylesheet HREF="style.css" TYPE="text/css">
<SCRIPT LANGUAGE="JavaScript">
function validateCust(form) 
{
	if(form.mer_name.value=="" )
	{
		alert("Please enter your name");
		form.mer_name.focus();
		return false;
	}
	if(form.mer_email.value=="" )
	{
		alert("Please enter your email address");
		form.mer_email.focus();
		return false;
	}
	else if(form.mer_email.value.indexOf("@")=="-1" ||
			form.mer_email.value.indexOf(".")=="-1" )
	{
		alert("Please enter a valid email address");
		form.mer_email.select();
		form.mer_email.focus();
		return false;
	}
	if(form.mer_pwd.value=="")
	{
		alert("Please enter a password");
		form.mer_pwd.select();
		form.mer_pwd.focus();
		return false;
	}
	if(form.cpwd.value!=form.mer_pwd.value)
	{
		alert("Please ensure you type in the same password twice");
		form.mer_pwd.select();
		form.mer_pwd.focus();
		return false;
	}
	
	if(form.mer_addr1.value=="" )
	{
		alert("Please complete your address");
		form.mer_addr1.focus();
		return false;
	}
	if(form.mer_web.value=="" )
	{
		alert("Please complete your web address");
		form.mer_web.focus();
		return false;
	}
	if(form.mer_key.value=="" )
	{
		alert("Please complete enter your authentication key");
		form.mer_key.focus();
		return false;
	}

	if(form.mer_addr3.value=="" )
	{
		alert("Please complete your address");
		form.mer_addr3.focus();
		return false;
	}
	if(form.mer_region.value=="" )
	{
		alert("Please enter your County / State");
		form.mer_region.focus();
		return false;
	}
	if(form.mer_country.value=="" )
	{
		alert("Please enter your country");
		form.mer_country.focus();
		return false;
	}
	if(form.mer_zip.value=="" )
	{
		alert("Please enter a Post Code / Zip Code");
		form.mer_zip.focus();
		return false;
	}
	if(form.mer_phone.value=="" )
	{
		alert("Please enter your telephone number");
		form.mer_phone.focus();
		return false;
	}
	return true;
}
</script>

</head>
<body>
<div align="center">
<h3>ClickClocker Merchant Set Up</h3>
<form action="mer_setup.${pft}" method="post" onSubmit="return validateCust(this)">
<table width="600" border="0" cellspacing="0" cellpadding="0" class="a">
<tr>
	<td class=a>&nbsp;</td>
	<td class=a valign="top" colspan="2"><br>
		<b>Contact Details</b>
		<br><br>
	</td>
	<td class=a>&nbsp;</td>
</tr>
<tr>
	<td class=a>&nbsp;</td>
	<td class=a valign="top">Name</td>
	<td class=a valign="top"><input type="text" name="mer_name" size="40" maxlength="50"></input><br></td>
	<td class=a>&nbsp;</td>
</tr>
<tr>
	<td class=a>&nbsp;</td>
	<td class=a valign="top">Email</td>
	<td class=a valign="top"><input type="text" name="mer_email" size="40" maxlength="50"></input><br></td>
	<td class=a>&nbsp;</td>
</tr>
<tr>
	<td class=a>&nbsp;</td>
	<td class=a valign="top">Password</td>
	<td class=a valign="top"><input type="password" name="mer_pwd" size="10" maxlength="15"></input><br></td>
	<td class=a>&nbsp;</td>
</tr>
<tr>
	<td class=a>&nbsp;</td>
	<td class=a valign="top">Confirm Password</td>
	<td class=a valign="top"><input type="password" name="cpwd" size="10" maxlength="15"></input><br></td>
	<td class=a>&nbsp;</td>
</tr>
<tr>
	<td class=a>&nbsp;</td>
	<td class=a valign="top" colspan="2"><br>
		<b>Company Details</b><br><br></td>
	<td class=a>&nbsp;</td>
</tr>
<tr>
	<td class=a>&nbsp;</td>
	<td class=a valign="top">Company Name</td>
	<td class=a valign="top"><input type="text" name="mer_org" size="30" maxlength="100"></input><br></td>
	<td class=a>&nbsp;</td>
</tr>
<tr>
	<td class=a>&nbsp;</td>
	<td class=a valign="top">VAT Reg. No.</td>
	<td class=a valign="top"><input type="text" name="mer_vat_no" size="20" maxlength="30"></input><br></td>
	<td class=a>&nbsp;</td>
</tr>
<tr>
	<td class=a>&nbsp;</td>
	<td class=a valign="top">Web Site URL</td>
	<td class=a valign="top"><b>http://</b><input type="text" name="mer_web" size="30" maxlength="255"></input><br></td>
	<td class=a>&nbsp;</td>
</tr>
<tr>
	<td class=a>&nbsp;</td>
	<td class=a valign="top">Product Key</td>
	<td class=a valign="top"><input type="text" name="mer_key" size="30" maxlength="255"></input><br></td>
	<td class=a>&nbsp;</td>
</tr>

<tr>
	<td class=a>&nbsp;</td>
	<td class=a valign="top">Address</td>
	<td class=a valign="top"><input type="text" name="mer_addr1" size="30" maxlength="50"></input><br></td>
	<td class=a>&nbsp;</td>
</tr>
<tr>
	<td class=a>&nbsp;</td>
	<td class=a valign="top">&nbsp;</td>
	<td class=a valign="top"><input type="text" name="mer_addr2" size="30" maxlength="50"></input><br></td>
	<td class=a>&nbsp;</td>
</tr>
<tr>
	<td class=a>&nbsp;</td>
	<td class=a valign="top">Town/City</td>
	<td class=a valign="top"><input type="text" name="mer_addr3" size="30" maxlength="50"></input><br></td>
	<td class=a>&nbsp;</td>
</tr>
<tr>
	<td class=a>&nbsp;</td>
	<td class=a valign="top">County/Region</td>
	<td class=a valign="top"><input type="text" name="mer_region" size="30" maxlength="50"></input><br></td>
	<td class=a>&nbsp;</td>
</tr>
<tr>
	<td class=a>&nbsp;</td>
	<td class=a valign="top">Country</td>
	<td class=a valign="top"><input type="text" name="mer_country" size="30" maxlength="50"></input><br></td>
	<td class=a>&nbsp;</td>
</tr>
<tr>
	<td class=a>&nbsp;</td>
	<td class=a valign="top">Postcode/ZIP</td>
	<td class=a valign="top"><input type="text" name="mer_zip" size="10" maxlength="15"></input><br></td>
	<td class=a>&nbsp;</td>
</tr>
<tr>
	<td class=a>&nbsp;</td>
	<td class=a valign="top">Telephone</td>
	<td class=a valign="top"><input type="text" name="mer_phone" size="20" maxlength="20"></input><br></td>
	<td class=a>&nbsp;</td>
</tr>
<tr><td class=a colspan="4">&nbsp;</td></tr>
<tr>
	<td class=a colspan="2">&nbsp;</td>
	<td class=a valign="top"><input type="submit" name="step2" value="Set Up and Register"><br><br></td>
	<td class=a>&nbsp;</td>
</tr>
</table>
</form>
<br>
</div>
</body>
</html>

(END MESSAGE2)
