#!/usr/bin/perl
use File::Basename; 
use lib dirname ($0);
use AffiliateLib;

my %months = (
	'Jan', '01', 'Feb', '02', 'Mar', '03', 'Apr', '04', 'May', '05', 'Jun', '06', 
	'Jul', '07', 'Aug', '08', 'Sep', '09', 'Oct', '10', 'Nov', '11', 'Dec', '12' );

################# read form
&read_form;

if($formdata{'auth'}) {
    $auth = $formdata{'auth'};
} else {
	################# read passed vars
	use CGI qw(param);
	$auth = param("auth");
}

################# read merchant record
%merchant = get_merchant($auth, 1); # 1=authenticate

# process manual sale
if($formdata{'sales_id'}) {

	################# set date
	open(TODAYSDATE, "${ccpath}today |");
	$today = <TODAYSDATE>;
	close TODAYSDATE;

	$formdata{'sales_id'} =~ tr/+/ /;
	$formdata{'sales_id'} =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	$formdata{'description'} =~ tr/+/ /;
	$formdata{'description'} =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	
	################# construct clickclocker filename
	$cclogfile = "cc" . 
		substr($today, 9, 2) . 
		$months{substr($today, 3, 3)} .
		substr($today, 0, 2) . ".csv";
			
	################# write a record to impression log to ensure sale is found
	open FILEHANDLE, ">>${ccpath}log/${cclogfile}" or error_msg("Cannot open file ${ccpath}log/${cclogfile}");
	print FILEHANDLE "manual,"; # banner
	print FILEHANDLE "$formdata{'affiliate_sel'}\n";
	close FILEHANDLE;

	################# write sale to file
	open FILEHANDLE, ">>${ccpath}reports/sales.csv" or error_msg("Cannot open file reports/sales.csv");

	print FILEHANDLE "$today,";
	print FILEHANDLE "$formdata{'affiliate_sel'},";
	print FILEHANDLE "manual,"; # banner
	print FILEHANDLE "$formdata{'sales_id'},";
	print FILEHANDLE "$formdata{'sales_amount'},";
	print FILEHANDLE "$formdata{'aff_method'},";
	print FILEHANDLE "0,";
	print FILEHANDLE "$formdata{'description'},";

	if($formdata{'aff_method'} eq "F") {
		print FILEHANDLE "$formdata{'aff_fix'}\n";
	} else {
		print FILEHANDLE "$formdata{'aff_com'}\n";
	}
	close FILEHANDLE;
}


################# write form
&page_top("Sales Admin");
&mer_nav($merchant{'mer_email'});

print "<h3>Manual Sales Entry</h3>";
print "<form name=report action=\"mer_telsales.${pft}\" method=post onSubmit=\"return validateForm(this)\">";
print "<input type=hidden name=auth value=\"$auth\">";
print "<input type=hidden name=aff_method value=\"$aff{'aff_method'}\">";

print "<table border=0 cellspacing=0 cellpadding=0>";
print "<tr><td valign=top>Affiliate</td>";
print "<td colspan=2><select name=\"affiliate_sel\">";
print "<option value=\"none\" selected>--select affiliate--</option>";

################## get affiliates
opendir(DIRECTORY, "${ccpath}accepted") or error_msg( "Can't open directory accepted");
$files = join (',', readdir(DIRECTORY));
@filelist = split(/,/, $files);
closedir DIRECTORY;

################# display affiliates
foreach $affiliate (@filelist) 
{
	if($affiliate =~ /@/ && open FILEHANDLE, "<${ccpath}accepted/$affiliate")
	{
		%aff = split(" ", <FILEHANDLE>);
		close FILEHANDLE;

		foreach $key (keys %aff) {
	    	$aff{$key} =~ tr/~/ /;
			$aff{$key} =~ tr/+/ /;
			$aff{$key} =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		}

		print "<option value=\"$aff{'aff_web'}\">$aff{'aff_web'}</option>";
	}
}

print "</td></tr>";




print "<tr><td valign=top>Sales Id</td>";
print "<td valign=top colspan=2><input type=text name=sales_id size=20 maxlength=50> (unique order number)<br></td></tr>";
print "<tr><td valign=top>Description</td>";
print "<td valign=top colspan=2><input type=text name=description size=40 maxlength=50> (optional)<br></td></tr>";

print "<tr><td valign=top>Sales Amount</td>";
print "<td valign=top colspan=2><input type=text name=sales_amount size=15 maxlength=20> (total order value)<br></td></tr>";

print "<tr><td valign=top>Commission&nbsp;Method</td>";
print "<td valign=top align=left>";
print "<input type=radio value=\"F\" name=aff_method>Fixed<br>";
print "<input type=radio value=\"C\" name=aff_method checked>Percentage</td>";
print "<td valign=top><b>&pound; &nbsp;</b><input type=text style='text-align:right' value=\"0.00\" name=aff_fix size=12 maxlength=12><br>";
print "<b>% </b><input type=text style='text-align:right' name=aff_com size=12 maxlength=12 value=\"0.0\"></td></tr>";
	
print "</table><br>\n";

print "<input type=submit name=sales_admin value='Create Order'>";

print <<"(END HTML2)";
</form>
<br>
<SCRIPT LANGUAGE="JavaScript">
function validateForm(form) 
{
	if(form.affiliate_sel.value=="none")
	{
		alert("Please select an affiliate");
		form.affiliate_sel.select();
		form.affiliate_sel.focus();
		return false;
	}
	if(form.sales_id.value=="")
	{
		alert("Please enter a Sales Id");
		form.sales_id.select();
		form.sales_id.focus();
		return false;
	}
	if(form.sales_amount.value=="")
	{
		alert("Please enter the invoice total");
		form.sales_amount.select();
		form.sales_amount.focus();
		return false;
	}

	return true;
}
</script>
(END HTML2)

&page_btm;

