#!/usr/bin/perl
use File::Basename; 
use lib dirname ($0);
use AffiliateLib;

%merchant = get_merchant;
$toEmail = "$merchant{'mer_email'}";

################# read form
&read_form;

################# check email not already in affiliate files
if($formdata{'aff_email'}) {

$formdata{'aff_email'} =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;

opendir(DIRECTORY, "${ccpath}applications") or &error_msg( "Can't open directory applications");
$filelist = join (', ', readdir(DIRECTORY));

if($filelist =~ /$formdata{'aff_email'}/) {
	&error_msg("You have already submitted an application - $formdata{'aff_email'}");
}
closedir DIRECTORY;

opendir(DIRECTORY, "${ccpath}rejected") or error_msg( "Can't open directory accepted");
$filelist = join (', ', readdir(DIRECTORY));

if($filelist =~ /$formdata{'aff_email'}/) {
	&error_msg("We are sorry, but your previous application to join our affiliate program has been rejected.");
}
closedir DIRECTORY;

opendir(DIRECTORY, "${ccpath}accepted") or error_msg( "Can't open directory accepted");
$filelist = join (', ', readdir(DIRECTORY));

if($filelist =~ /$formdata{'aff_email'}/) {
	&error_msg("You have already been accepted on our affiliate program");
}
closedir DIRECTORY;

################# write login request to affiliate application file

$formdata{'id'} = get_next('affiliate');

if($formdata{'aff_vat_no'} eq "") {
	$formdata{'aff_vat_no'}="~";
}
if($formdata{'aff_addr2'} eq "") {
	$formdata{'aff_addr2'}="~";
}

$formdata{'aff_web'} = $formdata{'aff_url'};
$formdata{'aff_web'} =~ s/www\.//i;
$formdata{'aff_url'} = "http://" . $formdata{'aff_url'};

open(TODAYSDATE, "${ccpath}today |");
$formdata{'aff_date'} = <TODAYSDATE>;
close TODAYSDATE;

open FILEHANDLE, ">${ccpath}applications/$formdata{'aff_email'}" or error_msg( "Cannot open file applications/$formdata{'aff_email'}");

$, = " ";

print FILEHANDLE %formdata;
close FILEHANDLE;

	
foreach $key (keys %formdata) {
	$formdata{$key} =~ tr/+/ /;
	$formdata{$key} =~ s/~//;
	$formdata{$key} =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
}

################ inform merchant
&ccsendmail(
	$toEmail,
	$toEmail,
	"New affilate application", 
	"Dear Affiliate Manager,\n\nA new affiliate application has been received from $formdata{'aff_org'} who would like to display your banners at $formdata{'aff_url'}\n\nContact details : \n\nName : $formdata{'aff_name'}\nEmail : $formdata{'aff_email'}\nVAT No. $formdata{'aff_vat_no'}\nAddress : $formdata{'aff_addr1'}, $formdata{'aff_addr2'}, $formdata{'aff_addr3'}, $formdata{'aff_region'}, $formdata{'aff_country'}, $formdata{'aff_zip'}\nTelephone : $formdata{'aff_phone'}\n\nPlease use the control panel at $merchant{'mer_web'}/${ccwebpath}/mer_signin.${pft} to accept / reject this affiliate. \n\nThankyou.\n\n\n");


# display info to affiliate
print <<"(END MESSAGE)";
Content-type: text/html

<html>
<head>
<title>New Affiliate Application</title>
<LINK REL=stylesheet HREF="style.css" TYPE="text/css">
</head>

<body bgcolor="Silver">
<br>
<div align="center">
<table border=0 cellspacing=0 cellpadding=0>
<TR>
<TD bgcolor="silver" width="23"><IMG height=20 src="images/curve-tl.gif" width=23 border=0></TD>
<TD colspan="3" width="550"><IMG height=2 src="images/blank.gif" width=550 border=0></TD>
<TD bgcolor="silver" width="23"><IMG height=20 src="images/curve-tr.gif" width=23 border=0></TD>
</TR>
<tr><td width="23">&nbsp;</td>
<td valign="top" align="center" colspan=3>

<h3>Application successfully submitted for approval</h3>
<font size="-1">Thankyou for your application to our affiliate program.<br><br>
Your application will be reviewed shortly.<br><br>
You will be notified of our decision by email.</font>
<br><br>
<a href=/>Return to Home Page</a>
<br><br>
(END MESSAGE)

} else {

print <<"(END MESSAGE2)";
Content-type: text/html

<html>
<head>
<title>New Affiliate Application</title>
<LINK REL=stylesheet HREF="style.css" TYPE="text/css">

<SCRIPT LANGUAGE="JavaScript">
<!--
function validateCust(form) 
{
	var wtest = /\w+/
	var antest = /^[a-zA-Z0-9]+/


	if(! form.aff_name.value.match(antest))
	{
		alert("Please enter your name");
		form.aff_name.focus();
		return false;
	}
	if(! form.aff_email.value.match(antest))
	{
		alert("Please enter your email address");
		form.aff_email.focus();
		return false;
	}
	else if(form.aff_email.value.indexOf("@")=="-1" ||
			form.aff_email.value.indexOf(".")=="-1" )
	{
		alert("Please enter a valid email address");
		form.aff_email.select();
		form.aff_email.focus();
		return false;
	}
	if(! form.aff_pwd.value.match(antest))
	{
		alert("Please enter a password");
		form.aff_pwd.select();
		form.aff_pwd.focus();
		return false;
	}
	if(form.cpwd.value!=form.aff_pwd.value)
	{
		alert("Please ensure you type in the same password twice");
		form.aff_pwd.select();
		form.aff_pwd.focus();
		return false;
	}
	
	if(! form.aff_org.value.match(antest))
	{
		alert("Please enter a company name or the name you would like written on commission cheques");
		form.aff_org.focus();
		return false;
	}

	if(form.aff_url.value=="" )
	{
		alert("Please complete your web address");
		form.aff_url.focus();
		return false;
	}
  
  	if (!form.aff_url.value.match(wtest)) {                           
  		alert('please enter a valid web url');
  		form.aff_url.select();
		form.aff_url.focus();
    	return false;
  	}
	if( form.aff_url.value.indexOf(".") == "-1" ||
		form.aff_url.value.indexOf(",") != "-1" )
	{
		alert("Please enter a valid web url");
		form.aff_url.select();
		form.aff_url.focus();
		return false;
	}


	if(! form.aff_addr1.value.match(antest))
	{
		alert("Please complete your address");
		form.aff_addr1.focus();
		return false;
	}
	if(! form.aff_addr3.value.match(antest))
	{
		alert("Please complete your address");
		form.aff_addr3.focus();
		return false;
	}
	if(! form.aff_region.value.match(antest))
	{
		alert("Please enter your County / State");
		form.aff_region.focus();
		return false;
	}
	if(! form.aff_country.value.match(antest))
	{
		alert("Please enter your country");
		form.aff_country.focus();
		return false;
	}
	if(! form.aff_zip.value.match(antest))
	{
		alert("Please enter a Post Code / Zip Code");
		form.aff_zip.focus();
		return false;
	}
	if(! form.aff_phone.value.match(antest))
	{
		alert("Please enter your telephone number");
		form.aff_phone.focus();
		return false;
	}
	return true;
}
//-->
</script>

</head>

<body bgcolor="Silver">
<br>
<div align="center">
<table border=0 cellspacing=0 cellpadding=0>
<TR>
<TD bgcolor="silver" width="23"><IMG height=20 src="images/curve-tl.gif" width=23 border=0></TD>
<TD colspan="3" width="550"><IMG height=2 src="images/blank.gif" width=550 border=0></TD>
<TD bgcolor="silver" width="23"><IMG height=20 src="images/curve-tr.gif" width=23 border=0></TD>
</TR>
<tr><td width="23">&nbsp;</td>
<td valign="top" align="center" colspan="3">

<h3>New Affiliate Application</h3>

<form action="signup.${pft}" method="post" onSubmit="return validateCust(this)">
<table width="600" border="0" cellspacing="0" cellpadding="0" class="a">

<tr><td colspan=3 align=center class=a>Please make seperate applications for each website.<br></td></tr>

<tr>
	<td class=a>&nbsp;</td>
	<td class=a valign="top" colspan="2"><br>
		<b>Contact Details</b>
		<br><br>
	</td>
	<td class=a>&nbsp;</td>
</tr>
<tr>
	<td class=a>&nbsp;</td>
	<td class=a valign="top">Name</td>
	<td class=a valign="top"><input type="text" name="aff_name" size="40" maxlength="50"></input><br></td>
	<td class=a>&nbsp;</td>
</tr>
<tr>
	<td class=a>&nbsp;</td>
	<td class=a valign="top">Email</td>
	<td class=a valign="top"><input type="text" name="aff_email" size="40" maxlength="50"></input><br></td>
	<td class=a>&nbsp;</td>
</tr>
<tr>
	<td class=a>&nbsp;</td>
	<td class=a valign="top">Password</td>
	<td class=a valign="top"><input type="password" name="aff_pwd" size="10" maxlength="15"></input><br></td>
	<td class=a>&nbsp;</td>
</tr>
<tr>
	<td class=a>&nbsp;</td>
	<td class=a valign="top">Confirm Password</td>
	<td class=a valign="top"><input type="password" name="cpwd" size="10" maxlength="15"></input><br></td>
	<td class=a>&nbsp;</td>
</tr>
<tr>
	<td class=a>&nbsp;</td>
	<td class=a valign="top" colspan="2"><br>
		<b>Company Details</b><br><br></td>
	<td class=a>&nbsp;</td>
</tr>
<tr>
	<td class=a>&nbsp;</td>
	<td class=a valign="top">Company Name</td>
	<td class=a valign="top"><input type="text" name="aff_org" size="30" maxlength="50"></input>&nbsp;or name on cheque<br></td>
	<td class=a>&nbsp;</td>
</tr>
<tr>
	<td class=a>&nbsp;</td>
	<td class=a valign="top">VAT Reg. No.</td>
	<td class=a valign="top"><input type="text" name="aff_vat_no" size="20" maxlength="30"></input><br></td>
	<td class=a>&nbsp;</td>
</tr>
<tr>
	<td class=a>&nbsp;</td>
	<td class=a valign="top">Web Site URL</td>
	<td class=a valign="top"><b>http://</b><input type="text" name="aff_url" size="40" maxlength="255"></input><br></td>
	<td class=a>&nbsp;</td>
</tr>
<tr>
	<td class=a>&nbsp;</td>
	<td class=a valign="top">Address</td>
	<td class=a valign="top"><input type="text" name="aff_addr1" size="30" maxlength="50"></input><br></td>
	<td class=a>&nbsp;</td>
</tr>
<tr>
	<td class=a>&nbsp;</td>
	<td class=a valign="top">&nbsp;</td>
	<td class=a valign="top"><input type="text" name="aff_addr2" size="30" maxlength="50"></input><br></td>
	<td class=a>&nbsp;</td>
</tr>
<tr>
	<td class=a>&nbsp;</td>
	<td class=a valign="top">Town/City</td>
	<td class=a valign="top"><input type="text" name="aff_addr3" size="30" maxlength="50"></input><br></td>
	<td class=a>&nbsp;</td>
</tr>
<tr>
	<td class=a>&nbsp;</td>
	<td class=a valign="top">County/Region</td>
	<td class=a valign="top"><input type="text" name="aff_region" size="30" maxlength="50"></input><br></td>
	<td class=a>&nbsp;</td>
</tr>
<tr>
	<td class=a>&nbsp;</td>
	<td class=a valign="top">Country</td>
	<td class=a valign="top"><input type="text" name="aff_country" size="30" maxlength="50"></input><br></td>
	<td class=a>&nbsp;</td>
</tr>
<tr>
	<td class=a>&nbsp;</td>
	<td class=a valign="top">Postcode/ZIP</td>
	<td class=a valign="top"><input type="text" name="aff_zip" size="10" maxlength="15"></input><br></td>
	<td class=a>&nbsp;</td>
</tr>
<tr>
	<td class=a>&nbsp;</td>
	<td class=a valign="top">Telephone</td>
	<td class=a valign="top"><input type="text" name="aff_phone" size="20" maxlength="20"></input><br></td>
	<td class=a>&nbsp;</td>
</tr>
<tr><td class=a colspan="4">&nbsp;</td></tr>
<tr>
	<td class=a colspan="2">&nbsp;</td>
	<td class=a valign="top"><input type="submit" name="step2" value="Submit Application"><br><br></td>
	<td class=a>&nbsp;</td>
</tr>
</table>
</form>

(END MESSAGE2)
}

&page_btm;