#!/usr/bin/perl
use File::Basename; 
use lib dirname ($0);
use AffiliateLib;

my %months = (
	'Jan', 1, 'Feb', 2, 'Mar', 3, 'Apr', 4, 'May', 5, 'Jun', 6, 
	'Jul', 7, 'Aug', 8, 'Sep', 9, 'Oct', 10, 'Nov', 11, 'Dec', 12 );

my %amonths = (
	'Jan', '01', 'Feb', '02', 'Mar', '03', 'Apr', '04', 'May', '05', 'Jun', '06', 
	'Jul', '07', 'Aug', '08', 'Sep', '09', 'Oct', '10', 'Nov', '11', 'Dec', '12' );

################# read form
&read_form;

if($formdata{'aff'}) {
	$aff = $formdata{'aff'};
} else {

	################# read passed vars
	use CGI qw(param);
	$aff = param("aff");
	
	$formdata{'report_type'}=0;
}

$aff =~ tr/+/ /;
$aff =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;

################# get merchant record
%merchant = get_merchant;

################# read affiliate details
%affiliate = get_affiliate($aff);

################# make sure stats are up to date
@progs=("${ccpath}${ccprog} ${ccexecpath}");
system(@progs);

################# read yesterday's date
open(YESTERDAY, "${ccpath}yesterday |");
$yesterday = <YESTERDAY>;
close YESTERDAY;

if($formdata{'startday'} ne "") {

	($y_endday,$y_endmonth,$y_endyear) = split(/\//, $yesterday);

	$startday = $formdata{'startday'};
	$startmonth = $formdata{'startmonth'};
	$startyear = $formdata{'startyear'};

	$endday = $formdata{'endday'};
	$endmonth = $formdata{'endmonth'};
	$endyear = $formdata{'endyear'};

	########### test end date !gt yesterday
	$argmonth = $months{$endmonth}-1;
	$argymonth = $months{$y_endmonth}-1;
	$args = "$endday $argmonth $endyear $y_endday $argymonth $y_endyear";
	open(COMM1, "${ccpath}diffdate $args |");
	$result = <COMM1>;
	close COMM1;

	if($result eq "1") {
		($endday,$endmonth,$endyear) = split(/\//, $yesterday);
	}

	########### test start date !gt end date
	$argsmonth = $months{$startmonth}-1;
	$argemonth = $months{$endmonth}-1;
	$args = "$startday $argsmonth $startyear $endday $argemonth $endyear";
	open(COMM2, "${ccpath}diffdate $args |");
	$result = <COMM2>;
	close COMM2;

	if($result eq "1") {
		$startday = "01";
		$startmonth = $endmonth;
		$startyear = $endyear;
	}

	$from_date = "$startday/$startmonth/$startyear";
	$to_date = "$endday/$endmonth/$endyear";

} else {

	($endday,$endmonth,$endyear) = split(/\//, $yesterday);
	$startday = "01";
	$startmonth = $endmonth;
	$startyear = $endyear;

	$from_date = "$startday/$startmonth/$startyear";
	$to_date = "$endday/$endmonth/$endyear";
}

################# write form

&page_top("Affiliate Reports");

&aff_nav($aff);

print <<"(END MESSAGE)";
<h3>Report Controls</h3>
<form name=report action="stats.${pft}" method="post" onSubmit="return validateYr(this)">
<table border="0" cellspacing="0" cellpadding="0">
<tr><td valign="top">Report Type&nbsp;&nbsp;</td>
	<td colspan="3"><select name="report_type">
	<option value="0" selected>Summary Report&nbsp;</option>
	<option value="1">Links Analysis</option>
	<option value="2">Confirmed Sales</option>
	<option value="3">Paid Sales</option>
</select><BR><BR></td>
</tr>
<tr><td>&nbsp;</td><td>Day</td><td>Month</td><td>Year</td></tr>
<tr><td valign="top">Start Date</td><td>
	<select name="startday">
		<option value="01">01</option>
		<option value="02">02</option>
		<option value="03">03</option>
		<option value="04">04</option>
		<option value="05">05</option>
		<option value="06">06</option>
		<option value="07">07</option>
		<option value="08">08</option>
		<option value="09">09</option>
		<option value="10">10</option>
		<option value="11">11</option>
		<option value="12">12</option>
		<option value="13">13</option>
		<option value="14">14</option>
		<option value="15">15</option>
		<option value="16">16</option>
		<option value="17">17</option>
		<option value="18">18</option>
		<option value="19">19</option>
		<option value="20">20</option>
		<option value="21">21</option>
		<option value="22">22</option>
		<option value="23">23</option>
		<option value="24">24</option>
		<option value="25">25</option>
		<option value="26">26</option>
		<option value="27">27</option>
		<option value="28">28</option>
		<option value="29">29</option>
		<option value="30">30</option>
		<option value="31">31</option>
	</select>
	</td><td>
	<select name="startmonth">
		<option value="Jan">Jan</option>
		<option value="Feb">Feb</option>
		<option value="Mar">Mar</option>
		<option value="Apr">Apr</option>
		<option value="May">May</option>
		<option value="Jun">Jun</option>
		<option value="Jul">Jul</option>
		<option value="Aug">Aug</option>
		<option value="Sep">Sep</option>
		<option value="Oct">Oct</option>
		<option value="Nov">Nov</option>
		<option value="Dec">Dec</option>

	</select>
	</td><td>
	<input size=4 name="startyear" value=$startyear maxlength=4>
	</td>
	<tr><td valign=top>End Date</td><td>
	<select name="endday">
		<option value="01">01</option>
		<option value="02">02</option>
		<option value="03">03</option>
		<option value="04">04</option>
		<option value="05">05</option>
		<option value="06">06</option>
		<option value="07">07</option>
		<option value="08">08</option>
		<option value="09">09</option>
		<option value="10">10</option>
		<option value="11">11</option>
		<option value="12">12</option>
		<option value="13">13</option>
		<option value="14">14</option>
		<option value="15">15</option>
		<option value="16">16</option>
		<option value="17">17</option>
		<option value="18">18</option>
		<option value="19">19</option>
		<option value="20">20</option>
		<option value="21">21</option>
		<option value="22">22</option>
		<option value="23">23</option>
		<option value="24">24</option>
		<option value="25">25</option>
		<option value="26">26</option>
		<option value="27">27</option>
		<option value="28">28</option>
		<option value="29">29</option>
		<option value="30">30</option>
		<option value="31">31</option>
	</select>
</td><td>
	<select name="endmonth">
		<option value="Jan">Jan</option>
		<option value="Feb">Feb</option>
		<option value="Mar">Mar</option>
		<option value="Apr">Apr</option>
		<option value="May">May</option>
		<option value="Jun">Jun</option>
		<option value="Jul">Jul</option>
		<option value="Aug">Aug</option>
		<option value="Sep">Sep</option>
		<option value="Oct">Oct</option>
		<option value="Nov">Nov</option>
		<option value="Dec">Dec</option>
	</select>
	<input type=hidden name=aff value="$aff"></input>
	</td><td><input size=4 value=$endyear name="endyear" maxlength=4>
	</td>
</tr>
<tr><td>&nbsp;</td></tr>
<tr>
	<td valign="top"><input type="submit" name="report" value="Run Report"><br><br></td>
</tr>
</table>
</form>

(END MESSAGE)

####################### Link Performance Analysis #################

if ($formdata{'report_type'} eq 1) {
	print "<h3>Link Performance Analysis&nbsp;";
	print "<a href=\"#\" onClick=\"alert(\'This report enables you to identify which banners work best for you and use this knowledge to improve your clickthroughs/sales performance.\\n\\nThe impressions figures show how many times a banner/link has been shown for the selected date range.\\n\\nThe CTR % (Click Through Ratio) shows the relative performance of your banners.\\n\\nConversion = Conversion ratio of visitors to sales\\n\\nNote that the CTR is also influenced by the location of a banner or link on your web page and the quality of\\nvisitors that page receives.\'); return false\"><img src=\"images/q.gif\" width=17 height=16 border=0 alt=\"Click for Help\"></a></h3>";
	print "<table cellpadding=3><tr class=d><td valign=top><font color=black>Link</font></td><td valign=top><font color=black>Impressions</font></td><td valign=top><font color=black>Clicks</font></td><td><font color=black>Unique Visitors</font></td><td valign=top><font color=black>CTR\%</font></td><td valign=top><font color=black>Num Sales</font></td><td valign=top><font color=black>Conversion\%</font></td></tr>";

	print "<tr class=a><td colspan=7 align=center><br>Sorry, this report is only available in <br><b><a href=\"http://www.clickclocker.com/professional.htm\">ClickClocker Professional</a></b><br><br></td></tr>";
	
	print "<tr class=c>";
	print "<td>Period Total</td>";
	print "<td align=right>&nbsp;</td>";
	print "<td align=right>&nbsp;</td>";
	print "<td align=right>&nbsp;</td>";
	print "<td align=right>&nbsp;</td>";
	print "<td align=right>&nbsp;</td>";
	print "<td align=right>&nbsp;</td>";
	print "</tr>";

$sales_msg = "Sales figures include pending sales";
} # end of report_type 1 - links


########################### Confirmed Sales ##########################

elsif ($formdata{'report_type'} eq 2) {
	print "<h3>Confirmed Sales&nbsp;";
	print "<a href=\"#\" onClick=\"alert(\'This report shows the confirmed orders across the selected date range.\\n\\nInvoices should be raised for the total commission earned and specify the selected date range.\'); return false\"><img src=\"images/q.gif\" width=17 height=16 border=0 alt=\"Click for Help\"></a></h3>";
	print "<table cellpadding=3><tr class=d><td><font color=black>Date</font></td><td><font color=black>Sale</font></td><td><font color=black>Value</font></td><td><font color=black>Commission</font></td></tr>";

	########### data
	my $sales_total = 0.0;
	my $comm_total = 0.0;
	my $cl;
	my %orders; # prevents duplicates
	
	# get paid
	open PAIDFILE, "<${ccpath}reports/sales_paid.csv";
	while($line = <PAIDFILE>) {
		($spaid_dte, $spaid_web, $spaid_banner, $spaid_order, $spaid_value, $spaid_type, $spaid_bonus, $spaid_name, $spaid_com) = split(/,/, $line);
		$salespaid{$spaid_order} = $spaid_order;
	}
	close PAIDFILE;

	open FILEHANDLE, "<${ccpath}reports/sales_approved.csv";
	while($line = <FILEHANDLE>) {

		my ($dte, $web, $banner, $order, $value, $sales_type, $sales_com, $sales_name, $aff_com) = split(/,/, $line);

		($day, $month, $year) =  split(/\//, $dte);
		
		next if $web ne $affiliate{'aff_web'};

		next if $salespaid{$order};
		
		next if $orders{$order}; # remove duplicates
		$orders{$order} = $order;

		next if $year<$startyear ||
		  ($year==$startyear && $months{$month}<$months{$startmonth}) ||
		  ($year==$startyear && $months{$month}==$months{$startmonth} && $day<$startday);

		last if $year>$endyear ||
		  ($year==$endyear && $months{$month}>$months{$endmonth}) ||
		  ($year==$endyear && $months{$month}==$months{$endmonth} && $day>$endday);

		$value = sprintf "%.2f", $value;
		$rep_line = "<td>$dte</td>";
		$rep_line .= "<td>$order - $sales_name</td>";
		$rep_line .= "<td align=right>$value</td>";

		$sales_total += $value;
			
		$commission = sprintf "%.2f", $sales_com;
		$comm_total += $commission;

		$rep_line .= "<td align=right>$commission</td></tr>";
		
		$sort_dte = $year . $amonths{$month} . $day . $order; # yymmdd plus order num
		$rep_lines{$sort_dte} = $rep_line;
	}
	close FILEHANDLE;
	
	foreach $key (sort keys %rep_lines) {
		$cl = ($cl eq "a") ? "b" : "a";
		print "<tr class=$cl>$rep_lines{$key}";
	}

	
	############# totals

	$comm_total = sprintf "%.2f", $comm_total;
	$sales_total = sprintf "%.2f", $sales_total;

	print "<tr class=c>";
	print "<td>Period Total</td>";
	print "<td>&nbsp;</td>";
	print "<td align=right>$sales_total</td>";
	print "<td align=right>$comm_total</td>";
	print "</tr>";

} # end of report_type 2 - Sales

########################### Paid Sales ##########################

elsif ($formdata{'report_type'} eq 3) {
	print "<h3>Paid Sales&nbsp;";
	print "<a href=\"#\" onClick=\"alert(\'This report shows the orders that have been processed for commission payment.\\n\\nTo check payments, use the date controls to match your invoice date ranges.\'); return false\"><img src=\"images/q.gif\" width=17 height=16 border=0 alt=\"Click for Help\"></a></h3>";
	print "<table cellpadding=3><tr class=d><td><font color=black>Date</font></td><td><font color=black>Sale</font></td><td><font color=black>Value</font></td><td><font color=black>Commission</font></td></tr>";

	########### data
	my $sales_total = 0.0;
	my $comm_total = 0.0;
	my $cl;
	my %orders; # prevents duplicates
	
	open FILEHANDLE, "<${ccpath}reports/sales_paid.csv";
	while($line = <FILEHANDLE>) {

		my ($dte, $web, $banner, $order, $value, $sales_type, $sales_com, $sales_name, $aff_com) = split(/,/, $line);

		($day, $month, $year) =  split(/\//, $dte);
		
		next if $web ne $affiliate{'aff_web'};
		
		next if $orders{$order}; # remove duplicates
		$orders{$order} = $order;

		next if $year<$startyear ||
		  ($year==$startyear && $months{$month}<$months{$startmonth}) ||
		  ($year==$startyear && $months{$month}==$months{$startmonth} && $day<$startday);

		last if $year>$endyear ||
		  ($year==$endyear && $months{$month}>$months{$endmonth}) ||
		  ($year==$endyear && $months{$month}==$months{$endmonth} && $day>$endday);

		$cl = ($cl eq "a") ? "b" : "a";	

		$value = sprintf "%.2f", $value;
		$rep_line = "<tr class=$cl><td>$dte</td>";
		$rep_line .= "<td>$order - $sales_name</td>";
		$rep_line .= "<td align=right>$value</td>";

		$sales_total += $value;
			
		$commission = sprintf "%.2f", $sales_com;
		$comm_total += $commission;

		$rep_line .= "<td align=right>$commission</td></tr>";
			
		$sort_dte = $year . $amonths{$month} . $day . $order; # yymmdd plus order num

		$rep_lines{$sort_dte} = $rep_line;
	}
	close FILEHANDLE;
	
	foreach $key (sort keys %rep_lines) {
		print $rep_lines{$key};
	}
	
	############# totals

	$comm_total = sprintf "%.2f", $comm_total;
	$sales_total = sprintf "%.2f", $sales_total;

	print "<tr class=c>";
	print "<td>Period Total</td>";
	print "<td>&nbsp;</td>";
	print "<td align=right>$sales_total</td>";
	print "<td align=right>$comm_total</td>";
	print "</tr>";

} # end of report_type 3 - Sales Paid


############################## Summary ##########################

else {
	print "<h3>Summary Report&nbsp;";
	print "<a href=\"#\" onClick=\"alert(\'This report shows statistics on a day by day basis.\\n\\nImpressions = the number of times a banner or link has been displayed on your web pages.\\n\\nThe CTR % (Click Through Ratio) shows the ratio of impressions to clicks\\n\\nCommission = Commission earned on confirmed sales.\\n\\nConversion = Conversion ratio of visitors to sales\\n\\nNote that pending sales may be rejected in the event of returns/fraud etc.\'); return false\"><img src=\"images/q.gif\" width=17 height=16 border=0 alt=\"Click for Help\"></a></h3>";
	print "<table cellpadding=3><tr class=d><td valign=top><font color=black>Date</font></td><td valign=top><font color=black>Impressions</font></td><td valign=top><font color=black>Clicks</font></td><td><font color=black>Unique Visitors</font></td><td><font color=black>CTR (\%)</font></td><td><font color=black>Num. Sales</font></td><td align=right><font color=black>Pending<br>Sales (&pound;)</font></td><td align=right><font color=black>Confirmed<br>Sales (&pound;)</font></td><td align=right><font color=black>Commission(&pound;)</font></td><td align=right><font color=black>Conversion(\%)</font></td></tr>";

	########### load approved file
	my %orders;
	open APPROVED, "<${ccpath}reports/sales_approved.csv";
	while($line = <APPROVED>) {
		
		($dte, $web, $banner, $order, $value, $method, $sales_com, $sales_name, $aff_com) = split(/,/, $line);

		$app_orders{$order} = $order;
		$approved_com{$order} = $sales_com;
		$approved_val{$order} = $value;
	}
	close APPROVED;

	########### data
	my $imp_total=0, $click_total=0;
	my $sales_total = 0.0;
	my $sales_num = 0;
	my $comm_total = 0.0;
	my $cl;
	my $lastdte;
	my $clicks=0;
	my $sales_tot = 0.0;
	my $pending = 0.0;
	my $pending_tot = 0.0;
	my $sales_com = 0.0;
	my $sales = 0;
	my $commission = 0.0;
	my $conversion = 0.0;
	my $date_done=0;

	# get rejected
	open REJSFILE, "<${ccpath}reports/sales_rejected.csv";
	while($line = <REJSFILE>) {
		($rejec_dte, $rejec_web, $rejec_banner, $rejec_order, $rejec_value, $rejec_type, $rejec_bonus, $rejec_name, $rejec_com) = split(/,/, $line);

		$rejected{$rejec_order} = $rejec_order;
	}
	close REJSFILE;

	open IMPRESSIONS, "<${ccpath}reports/clickclocker.csv";
	while($line = <IMPRESSIONS>) {

		($dte, $web, $banner, $imp) = split(/,/, $line);

		next if $web ne $affiliate{'aff_web'};

		($day, $month, $year) =  split(/\//, $dte);

		next if $year<$startyear ||
		  ($year==$startyear && $months{$month}<$months{$startmonth}) ||
		  ($year==$startyear && $months{$month}==$months{$startmonth} && $day<$startday);

		last if $year>$endyear ||
		  ($year==$endyear && $months{$month}>$months{$endmonth}) ||
		  ($year==$endyear && $months{$month}==$months{$endmonth} && $day>$endday);

		# create report line on change of date
		if(!$lastdte) {$lastdte = $dte;}
		elsif($dte ne $lastdte) {

			$cl = ($cl eq "a") ? "b" : "a";

			my $conversion = "&nbsp;";
			if($sales > 0 && $clicks > 0) {
				$conversion =  sprintf "%.2f", (100 * $sales / $clicks);
			}

			$commission = sprintf "%.2f", $commission;
			$pending = sprintf "%.2f", $pending;
			$sales_tot = sprintf "%.2f", $sales_tot;
	
			$rep_line = "<tr class=$cl><td>$lastdte</td><td align=right>#</td>";
			$rep_line .= "<td align=right>$clicks</td><td align=right>#</td><td align=right>#</td>";
			$rep_line .= "<td align=right>$sales</td>";
			$rep_line .= "<td align=right>$pending</td>";
			$rep_line .= "<td align=right>$sales_tot</td>";
			$rep_line .= "<td align=right>$commission</td><td align=right>$conversion</td></tr>";
			print $rep_line;
			
			$lastdte=$dte;
				
			$clicks=0;
			$sales_tot = 0.0;
			$pending = 0.0;
			$sales = 0;
			$commission = 0.0;
			$conversion = 0.0;
			$date_done=0;

		} # if change of date

		if(!$date_done) {
			# get clicks
			open CLICKFILE, "<${ccpath}reports/clicks.csv";
			while($line = <CLICKFILE>) {
				my ($click_dte, $click_web, $click_banner, $hour, $ip) = split(/,/, $line);
				if ($click_dte eq $dte && 
					$click_web eq $web )
				{
					$clicks++;
					$click_total++;
				}
			}
			close CLICKFILE;
			
			# get sales
			my %orders; # prevents duplicates

			open SALESFILE, "<${ccpath}reports/sales_pending.csv";
			while($line = <SALESFILE>) {
			
				($sales_dte, $sales_web, $sales_banner, $sales_order, $sales_value, $sales_type, $sales_bonus, $sales_name, $sales_com) = split(/,/, $line);
			
				if ($sales_dte eq $dte && $sales_web eq $web ) {
				
					next if $rejected{$sales_order};
					
					next if $orders{$sales_order}; # remove duplicates
					$orders{$sales_order} = $sales_order;
						
					if($app_orders{$sales_order} ne $sales_order) {
						$sales++;
						$sales_num++;
						$pending += $sales_value;
						$pending_tot += $sales_value;
					}
					else {
						$sales++;
						$sales_num++;
						$sales_tot += $approved_val{$sales_order};
						$sales_total += $approved_val{$sales_order};

						$commission += $approved_com{$sales_order};
						$comm_total += $approved_com{$sales_order};
					}
				}
			}
			close SALESFILE;

			$date_done=1;
		}
	} # while impressions

	close IMPRESSIONS;

	$cl = ($cl eq "a") ? "b" : "a";

	my $conversion = "&nbsp;";
	if($sales > 0 && $clicks > 0) {
		$conversion =  sprintf "%.2f", (100 * $sales / $clicks);
	}
	$pending = sprintf "%.2f", $pending;
	$sales_tot = sprintf "%.2f", $sales_tot;
	$commission = sprintf "%.2f", $commission;

	$rep_line = "<tr class=$cl><td>$lastdte</td><td align=right>#</td>";
	$rep_line .= "<td align=right>$clicks</td><td align=right>#</td><td align=right>#</td>";
	$rep_line .= "<td align=right>$sales</td>";
	$rep_line .= "<td align=right>$pending</td>";
	$rep_line .= "<td align=right>$sales_tot</td>";
	$rep_line .= "<td align=right>$commission</td><td align=right>$conversion</td></tr>";
	print $rep_line;

	
	############# totals
	my $conversion_total = "&nbsp;";

	if($sales_num > 0 && $click_total > 0) {
		$conversion_total = sprintf "%.2f", (100 * $sales_num / $click_total);
	}

	$comm_total = sprintf "%.2f", $comm_total;
	$sales_total = sprintf "%.2f", $sales_total;
	$pending_tot = sprintf "%.2f", $pending_tot;

	print "<tr class=c>";
	print "<td>Period Total</td>";
	print "<td align=right>#</td>";
	print "<td align=right>$click_total</td>";
	print "<td align=right>#</td>";
	print "<td align=right>#</td>";
	print "<td align=right>$sales_num</td>";
	print "<td align=right>$pending_tot</td>";
	print "<td align=right>$sales_total</td>";
	print "<td align=right>$comm_total</td>";
	print "<td align=right>$conversion_total</td>";
	print "</tr>";

$sales_msg = "";
$ccprofmsg = "# - Sorry, only available in <b><a href=\"http://www.clickclocker.com/professional.htm\">ClickClocker Professional</a></b><br>";

} # end of rpt type 0

print <<"(END HTML2)";
</table>
$ccprofmsg
$sales_msg
<br>
<SCRIPT LANGUAGE="JavaScript">
document.report.report_type.value = "$formdata{'report_type'}";
document.report.startday.value = "$startday";
document.report.startmonth.value = "$startmonth";
document.report.startyear.value = $startyear;
document.report.endday.value = "$endday";
document.report.endmonth.value = "$endmonth";
document.report.endyear.value = $endyear;

function validateYr(form) 
{
	if(form.startyear.value=="" || form.startyear.value < 2001)
	{
		alert("Please enter a start year in the format YYYY");
		form.startyear.select();
		form.startyear.focus();
		return false;
	}
	
	if(form.endyear.value=="")
	{
		alert("Please enter an end year");
		form.endyear.select();
		form.endyear.focus();
		return false;
	}
	else if(form.endyear.value < form.startyear.value)
	{
		alert("Please enter an end year greater than or equal to the start year");
		form.endyear.select();
		form.endyear.focus();
		return false;
	}
	return true;
}
</script>

(END HTML2)

&page_btm;